unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Spin,About,Stp,CooRead;

type
  TMainForm = class(TForm)
    StatusLine       : TPanel;
    ControlPanel     : TPanel;
    XYIndicator      : TPanel;
    DegIndicator     : TPanel;
    TraceIndicator   : TPanel;
    PowerIndicator   : TPanel;
    PortIndicator    : TPanel;
    ResetButon       : TButton;
    IncDegAButon     : TButton;
    DecDegAButon     : TButton;
    IncDegBButon     : TButton;
    DecDegBButon     : TButton;
    TraceButon       : TButton;
    PowerButon       : TButton;
    ExitButon        : TButton;
    AboutButon       : TButton;
    SetupButon       : TButton;
    Timer1           : TTimer;
    GoDegButon       : TButton;
    MXYIndicator     : TPanel;
    GoAbsButon       : TButton;
    procedure FormShow(Sender: TObject);
    procedure ExitButonClick(Sender: TObject);
    procedure AboutButonClick(Sender: TObject);
    procedure SetupButonClick(Sender: TObject);
    procedure TraceButonClick(Sender: TObject);
    procedure PowerButonClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure IncDegAButonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DecDegAButonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure IncDegBButonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DecDegBButonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GoDegButonClick(Sender: TObject);
    procedure GoAbsButonClick(Sender: TObject);
    procedure ResetButonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

type
    TButon = (IncDegA,DecDegA,IncDegB,DecDegB);

const
     ASegDeg     : integer = 10;
     BSegDeg     : integer = 10;
     Tracing     : boolean = False;
     OnPower     : boolean = False;
     ButonBasili : boolean = False;
     MouseDn     : boolean = False;
     PortArrange : array[1..8] of byte = (1,3,2,6,4,12,8,9);
     SegAInd     : byte = 1;
     SegBInd     : byte = 1;

var
   OldASegDeg,OldBSegDeg : integer;
   Orijin                : TPoint;
   BasiliButon           : TButon;

function StrLF(L:longint;F:byte):string;
var
   S : string;
begin
 Str(L:F,S);
 StrLF := S;
end;

function HexByte(Sayi : byte):string;
const
     HexRakam : array[0..15] of char =
      '0123456789ABCDEF';
begin
 HexByte := HexRakam[Sayi shr 4] + HexRakam[Sayi and 15];
end;

function HexWord(Sayi : word):string;
begin
 HexWord := HexByte(Sayi shr 8) + HexByte(Sayi and 255);
end;

procedure CalcXY(A,B: integer;var X,Y:integer);
var
   XA,YA : integer;
begin
 XA:=Orijin.X+Trunc(Setup.SegASize*cos((Pi*A)/Setup.SegARes));
 YA:=Orijin.Y+Trunc(Setup.SegASize*sin((Pi*A)/Setup.SegARes));
 X :=XA+Trunc(Setup.SegBSize*cos((Pi*A/Setup.SegARes)+(Pi*B/Setup.SegBRes)));
 Y :=YA+Trunc(Setup.SegBSize*sin((Pi*A/Setup.SegARes)+(Pi*B/Setup.SegBRes)));
end;

function CalcPortArrange:byte;
begin
 CalcPortArrange := PortArrange[SegAInd] or (PortArrange[SegBInd] shl 4);
end;

procedure Out32;stdcall;
var
   ByteValue : Byte;
   PortAdres : smallint;
begin
  PortAdres := Setup.PortAdres;
  ByteValue := CalcPortArrange;
  asm
     push dx
     mov dx, PortAdres
     mov al,ByteValue
     out dx,al
     pop dx
  end;
end;

procedure PortBosalt;assembler;
asm
   push dx
   mov dx,Setup.PortAdres
   xor ax,ax
   out dx,al
   pop dx
end;

procedure NOP;
begin
end;

procedure Delay(Dly: longint);
var
   I : longint;
begin
 for I := 0 to Dly do NOP;
end;

procedure LRGO(A,B: integer);
var
   AArti,BArti : boolean;
begin
 AArti := A > 0;
 BArti := B > 0;
 A := Abs(A);
 B := Abs(B);
 while A <> 0 do
  begin
   if AArti then
    begin
     Inc(SegAInd);
     if SegAInd > 8 then SegAInd := 1;
    end
   else
    begin
     Dec(SegAInd);
     if SegAInd < 1 then SegAInd := 8;
    end;
   Out32;
   Delay(Setup.DelayConst);
   Dec(A);
  end;
 while B <> 0 do
  begin
   if BArti then
    begin
     Inc(SegBInd);
     if SegBInd > 8 then SegBInd := 1;
    end
   else
    begin
     Dec(SegBInd);
     if SegBInd < 1 then SegBInd := 8;
    end;
   Out32;
   Delay(Setup.DelayConst);
   Dec(B);
  end;
end;

procedure DrawRobot;
var
   XA,YA        : integer;
   XB,YB        : integer;
   OldMode      : TPenMode;
   OldX,OldY    : integer;
begin
 if OnPower then LRGO(ASegDeg-OldASegDeg,BSegDeg-OldBSegDeg);
 OldMode := MainForm.Canvas.Pen.Mode;
 MainForm.Canvas.Pen.Mode := pmNotXor;
 XA := Orijin.X+Trunc(Setup.SegASize * cos((Pi*OldASegDeg)/Setup.SegARes));
 YA := Orijin.Y+Trunc(Setup.SegASize * sin((Pi*OldASegDeg)/Setup.SegARes));
 XB := XA + Trunc(Setup.SegBSize * cos((Pi*OldASegDeg/Setup.SegARes)
       +(Pi*OldBSegDeg/Setup.SegBRes)));
 YB := YA + Trunc(Setup.SegBSize * sin((Pi*OldASegDeg/Setup.SegARes)
       +(Pi*OldBSegDeg/Setup.SegBRes)));
 MainForm.Canvas.MoveTo(Orijin.X,Orijin.Y);
 MainForm.Canvas.LineTo(XA,YA);
 MainForm.Canvas.LineTo(XB,YB);
 OldX := XB;
 OldY := YB;
 XA := Orijin.X+Trunc(Setup.SegASize * cos((Pi*ASegDeg)/Setup.SegARes));
 YA := Orijin.Y+Trunc(Setup.SegASize * sin((Pi*ASegDeg)/Setup.SegARes));
 XB := XA + Trunc(Setup.SegBSize * cos((Pi*ASegDeg/Setup.SegARes)
       +(Pi*BSegDeg/Setup.SegBRes)));
 YB := YA + Trunc(Setup.SegBSize * sin((Pi*ASegDeg/Setup.SegARes)
       +(Pi*BSegDeg/Setup.SegBRes)));
 MainForm.Canvas.MoveTo(Orijin.X,Orijin.Y);
 MainForm.Canvas.LineTo(XA,YA);
 MainForm.Canvas.LineTo(XB,YB);
 MainForm.XYIndicator.Caption :='Lx:'+IntToStr(XB)+' Ly:'+IntToStr(YB);
 MainForm.DegIndicator.Caption:='a:'+IntToStr(ASegDeg)+'  b:'+IntToStr(BSegDeg);
 MainForm.Canvas.Pen.Mode := OldMode;
 if Tracing then
  begin
   OldMode := MainForm.Canvas.Pen.Mode;
   MainForm.Canvas.Pen.Mode := pmBlack;
   MainForm.Canvas.MoveTo(OldX,OldY);
   MainForm.Canvas.LineTo(XB,YB);
   MainForm.Canvas.Pen.Mode := OldMode;
  end;
end;

procedure InitLR;
var
   XA,YA,XB,YB : integer;
begin
 XA := Orijin.X+Trunc(Setup.SegASize * cos((Pi*ASegDeg)/Setup.SegARes));
 YA := Orijin.Y+Trunc(Setup.SegASize * sin((Pi*ASegDeg)/Setup.SegARes));
 XB := XA+Trunc(Setup.SegBSize*cos((Pi*ASegDeg/Setup.SegARes)
       +(Pi*BSegDeg/Setup.SegBRes)));
 YB := YA+Trunc(Setup.SegBSize*sin((Pi*ASegDeg/Setup.SegARes)
       +(Pi*BSegDeg/Setup.SegBRes)));
 MainForm.Canvas.MoveTo(Orijin.X,Orijin.Y);
 MainForm.Canvas.LineTo(XA,YA);
 MainForm.Canvas.LineTo(XB,YB);
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
 InitLR;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
   X,Y : integer;
begin
 OldASegDeg := ASegDeg;
 OldBSegDeg := BSegDeg;
 Canvas.Pen.Mode := pmNotXor;
 Width  := 580;
 Height := 460;
 Orijin.X := 0;
 Orijin.Y := 0;
 CalcXY(ASegDeg,BSegDeg,X,Y);
 XYIndicator.Caption  := 'Lx:'+IntToStr(X)+' Ly:'+IntToStr(Y);
 MXYIndicator.Caption  := 'Mx:'+IntToStr(X)+' My:'+IntToStr(Y);
 DegIndicator.Caption    := 'A:'+StrLF(ASegDeg,3)+'   B:'+StrLF(BSegDeg,3) ;
 PortIndicator.Caption   := HexWord(Setup.PortAdres);
 if Tracing then TraceIndicator.Caption := 'Tracing'
  else TraceIndicator.Caption := '';
 if OnPower then
  begin
   Out32;
   PowerIndicator.Caption := 'Power';
  end
 else
  begin
   PortBosalt;
   PowerIndicator.Caption := '';
  end;
end;

procedure TMainForm.ExitButonClick(Sender: TObject);
begin
 Close;
end;

procedure TMainForm.AboutButonClick(Sender: TObject);
begin
 AboutBox.ShowModal;
end;

procedure TMainForm.SetupButonClick(Sender: TObject);
begin
 SetupDlg.ShowModal;
 if SetupDlg.ModalResult = mrOk then
  begin
   Hide;
   Show;
  end;
end;

procedure TMainForm.TraceButonClick(Sender: TObject);
begin
 Tracing := not Tracing;
 if Tracing then TraceIndicator.Caption := 'Tracing'
  else TraceIndicator.Caption := ''
end;

procedure TMainForm.PowerButonClick(Sender: TObject);
begin
 OnPower := not OnPower;
 if OnPower then
  begin
   Out32;
   PowerIndicator.Caption := 'Power';
  end
 else
  begin
   PortBosalt;
   PowerIndicator.Caption := '';
  end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
 if ButonBasili then
  begin
   OldASegDeg := ASegDeg;
   OldBSegDeg := BSegDeg;
   case BasiliButon of
    IncDegA : Inc(ASegDeg);
    DecDegA : Dec(ASegDeg);
    IncDegB : Inc(BSegDeg);
    DecDegB : Dec(BSegDeg);
   end;
   DrawRobot;
  end;
end;

procedure TMainForm.ButonMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ButonBasili := False;
end;

procedure TMainForm.IncDegAButonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ButonBasili := True;
 BasiliButon := IncDegA;
end;

procedure TMainForm.DecDegAButonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ButonBasili := True;
 BasiliButon := DecDegA;
end;

procedure TMainForm.IncDegBButonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ButonBasili := True;
 BasiliButon := IncDegB;
end;

procedure TMainForm.DecDegBButonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ButonBasili := True;
 BasiliButon := DecDegB;
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   CosB,SinB : real;
   R         : real;
begin
 MXYIndicator.Caption := 'Mx:'+IntToStr(X)+'  My:'+IntToStr(Y);
 if ((Sqr(X)+Sqr(Y))>Sqr(Setup.SegASize+Setup.SegBSize))
     or (X<=0)
     or (Y<=0) then
   Cursor := crNo else Cursor := crHandPoint;
 if Setup.FollowCursor then
 if MouseDn then
 if Cursor <> crNo then
  begin
   OldASegDeg := ASegDeg;
   OldBSegDeg := BSegDeg;
   CosB := (Sqr(X)+Sqr(Y)-Sqr(Setup.SegASize)-Sqr(Setup.SegBSize))
          /(2.0*Setup.SegASize*Setup.SegBSize);
   SinB := Sqrt(1.0-Sqr(CosB));
   BSegDeg := Trunc((ArcTan(SinB/CosB)*Setup.SegBRes)/Pi);
   if BSegDeg < 0 then BSegDeg := BSegDeg+Setup.SegBRes;
   R:=ArcTan(Y/X);
   R:=R-ArcTan((Setup.SegBSize*SinB)/(Setup.SegASize+(Setup.SegBSize*CosB)));
   ASegDeg := Trunc((R*Setup.SegARes)/Pi);
   DrawRobot;
  end;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   CosB,SinB : real;
   R         : real;
begin
 MouseDn := True;
 if Cursor = crNo then Exit;
 OldASegDeg := ASegDeg;
 OldBSegDeg := BSegDeg;
 CosB := (Sqr(X)+Sqr(Y)-Sqr(Setup.SegASize)-Sqr(Setup.SegBSize))
        /(2.0*Setup.SegASize*Setup.SegBSize);
 SinB := Sqrt(1.0-Sqr(CosB));
 BSegDeg := Trunc((ArcTan(SinB/CosB)*Setup.SegBRes)/Pi);
 if BSegDeg < 0 then BSegDeg := BSegDeg+Setup.SegBRes;
 R := ArcTan(Y/X);
 R := R-ArcTan((Setup.SegBSize*SinB)/(Setup.SegASize+(Setup.SegBSize*CosB)));
 ASegDeg := Trunc((R*Setup.SegARes)/Pi);
 DrawRobot;
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 MouseDn := False;
end;

procedure TMainForm.GoDegButonClick(Sender: TObject);
begin
 CoReader.Caption := 'LR-Go Degrees';
 CoReader.Edit1.Text := IntToStr(ASegDeg);
 CoReader.Edit2.Text := IntToStr(BSegDeg);
 CoReader.Label1.Caption := 'Motor A';
 CoReader.Label2.Caption := 'Motor B';
 CoReader.ShowModal;
 if CoReader.ModalResult = mrOk then
  begin
   OldASegDeg := ASegDeg;
   OldBSegDeg := BSegDeg;
   ASegDeg    := StrToInt(CoReader.Edit1.Text);
   BSegDeg    := StrToInt(CoReader.Edit2.Text);
   DrawRobot;
  end;
end;

procedure TMainForm.GoAbsButonClick(Sender: TObject);
var
   X,Y       : integer;
   CosB,SinB : real;
   R         : real;
begin
 CalcXY(ASegDeg,BSegDeg,X,Y);
 CoReader.Caption := 'LR-Go Absolute';
 CoReader.Edit1.Text := IntToStr(X);
 CoReader.Edit2.Text := IntToStr(Y);
 CoReader.Label1.Caption := 'Motor A';
 CoReader.Label2.Caption := 'Motor B';
 CoReader.ShowModal;
 if CoReader.ModalResult = mrOk then
  begin
   X := StrToInt(CoReader.Edit1.Text);
   Y := StrToInt(CoReader.Edit2.Text);
   OldASegDeg := ASegDeg;
   OldBSegDeg := BSegDeg;
   CosB := (Sqr(X)+Sqr(Y)-Sqr(Setup.SegASize)-Sqr(Setup.SegBSize))
          /(2.0*Setup.SegASize*Setup.SegBSize);
   SinB := Sqrt(1.0-Sqr(CosB));
   BSegDeg := Trunc((ArcTan(SinB/CosB)*Setup.SegBRes)/Pi);
   if BSegDeg < 0 then BSegDeg := BSegDeg+Setup.SegBRes;
   R := ArcTan(Y/X);
   R := R-ArcTan((Setup.SegBSize*SinB)/(Setup.SegASize+(Setup.SegBSize*CosB)));
   ASegDeg := Trunc((R*Setup.SegARes)/Pi);
   DrawRobot;
  end;
end;

procedure TMainForm.ResetButonClick(Sender: TObject);
begin
 OldASegDeg := ASegDeg;
 OldBSegDeg := BSegDeg;
 ASegDeg    := 0;
 BSegDeg    := 0;
 DrawRobot;
end;

end.
